{fir2.dsp - FIR filter experiment - with separate stereo channels}
{Junior DSP Lab - Rutgers ECE Dept - S. J. Orfanidis - Jan 1996}

{Based on cfir.c or cfir2.c of Introduction to Signal Processing}

{--- define sampling rate in kHz: ----------------------------------------}
                    {0xc850 = 8      | 0xc851 = 5.5125   | 0xc852 = 16    }
                    {0xc853 = 11.025 | 0xc854 = 27.42857 | 0xc855 = 18.9  }
.const fs = 0xc850; {0xc856 = 32     | 0xc857 = 22.05    | 0xc859 = 37.8  }
                    {0xc85b = 44.1   | 0xc85c = 48       | 0xc85d = 33.075}
                    {0xc85e = 9.6    | 0xc85f = 6.615                     }
{-------------------------------------------------------------------------}

.include <c:\adi_dsp\macros\begin.dsp>;    {initializations and DSP macros}

{--- define constants, variables, and buffers ----------------------------}

.const M = 206;                    {designed by firlp.m or firhp.m}
.var/dm/circ wL[M+1];              {left delay-line buffer in DM}
.var/dm/circ wR[M+1];              {right delay-line buffer in DM}
.var/pm/circ h[M+1];               {filter coefficient buffer in PM}

i2 = ^wL; L2 = %wL;                {delay-line buffer pointer and length}
i3 = ^wR; L3 = %wR;                {delay-line buffer pointer and length}
i4 = ^h;  L4 = %h;                 {coefficient buffer pointer and length}

zero(i2, m2, L2);                  {clear left delay line}
zero(i3, m3, L3);                  {clear right delay line}

.init h: <fir.hex>;                {read coefficients in 1.15 hex format}
                                   {from file fir.hex}
{--- start processing input samples --------------------------------------}

wait: idle; jump wait;             {wait for interrupt and loop forever}
                                   {interrupt service routine starts here}
input_samples: ena sec_reg;        {enable secondary register set}

{--- read input samples from codec ---------------------------------------}

   ax1 = dm(rx_buf + 1);                  {left input sample}
   mx1 = dm(rx_buf + 2);                  {right input sample}

{--- sample processing algorithm --- process right input only ------------}

   cfir(M, i4, m4, i2, m2, ax1);          {input from ax1, output in mr1}
   ay1 = mr1;                             {left output}
   cfir(M, i4, m4, i3, m3, mx1);          {input from mx1, output in mr1}
   my1 = mr1;                             {right output}

{--- write output samples to codec ---------------------------------------}

   dm(tx_buf + 1) = ay1;                  {left output sample}
   dm(tx_buf + 2) = my1;                  {right output sample}

{--- return from interrupt -----------------------------------------------}

   rti;

.include <c:\adi_dsp\macros\end.dsp>;     {wrapup}
