{quantize.dsp - quantization to B bits}
{Junior DSP Lab - Rutgers ECE Dept - S. J. Orfanidis - Jan 1996}

{--- choose sampling rate in kHz: ----------------------------------------}
                    {0xc850 = 8      | 0xc851 = 5.5125   | 0xc852 = 16    }
                    {0xc853 = 11.025 | 0xc854 = 27.42857 | 0xc855 = 18.9  }
.const fs = 0xc85b; {0xc856 = 32     | 0xc857 = 22.05    | 0xc859 = 37.8  }
                    {0xc85b = 44.1   | 0xc85c = 48       | 0xc85d = 33.075}
                    {0xc85e = 9.6    | 0xc85f = 6.615                     }
{-------------------------------------------------------------------------}

.include <c:\adi_dsp\macros\begin.dsp>;    {initializations and DSP macros}

{--- define constants, variables, and buffers ----------------------------}

.const B = 6;                      {quantization bits per sample}
.const L = 16 - B;                 {L least-significant bits thrown away}

{--- start processing input samples --------------------------------------}

wait: idle; jump wait;             {wait for interrupt and loop forever}
                                   {interrupt service routine starts here}
input_samples: ena sec_reg;        {enable secondary register set}

{--- read input samples from codec ---------------------------------------}

   mr0 = dm(rx_buf + 1);           {left input sample}
   mr1 = dm(rx_buf + 2);           {right input sample}

{--- sample processing algorithm -----------------------------------------}

   sr = ashift mr0 by -L (hi);     {shift right by L bits}
   sr = ashift sr1 by  L (hi);     {shift left by L bits}
   mr0 = sr1;                      {requantized left sample}

   sr = ashift mr1 by -L (hi);     {shift right by L bits}
   sr = ashift sr1 by  L (hi);     {shift left by L bits}
   mr1 = sr1;                      {requantized right sample}

{--- write output samples to codec ---------------------------------------}

   dm(tx_buf + 1) = mr0;           {left output sample}
   dm(tx_buf + 2) = mr1;           {right output sample}

{--- return from interrupt -----------------------------------------------}

   rti;

.include <c:\adi_dsp\macros\end.dsp>;     {wrapup}
