{delex1.dsp - delay example using linear buffer}
{Junior DSP Lab - Rutgers ECE Dept - S. J. Orfanidis - Jan 1996}

{Based on Example 4.2.1 of Introduction to Signal Processing}

.include <c:\adi_dsp\macros\dspmac.dsp>;         {DSP macros}

.module/ram/abs=0  delex1;

.var/dm  x[8];                        {input samples}
.var/dm  y[11];                       {output samples}
.var/dm  w[4];                        {linear delay-line buffer in DM}

.init  x: <xfir.hex>;
.init  w: 0x0000, 0x0000, 0x0000, 0x0000;

        jump start; nop; nop; nop;               {Interupt vector table}
        rti; nop; nop; nop;                      {No interrupts used}
        rti; nop; nop; nop;
        rti; nop; nop; nop;
        rti; nop; nop; nop;
        rti; nop; nop; nop;
        rti; nop; nop; nop;

start:  i3 = ^x;  m3 = 1;  L3 = 0;        {input samples}
        i5 = ^y;  m5 = 1;  L5 = 0;        {output samples}

       cntr = 8;
       do outputs until ce;               {process 8 input samples}
              my1 = dm(w+3);              {get tap-3}
              dm(i5, m5) = my1;           {save in y and point to next y}

              mx1 = dm(i3, m3);           {read x and point to next x}
              dm(w) = mx1;                {put x in delay line}
                                          {update linear buffer}
              my0 = dm(w+2);              {w[2] = tap-2}
              dm(w+3) = my0;              {w[3] = w[2]}

              my0 = dm(w+1);              {w[1] = tap-1}
              dm(w+2) = my0;              {w[2] = w[1]}

              my0 = dm(w);                {w[0] = tap-0}
outputs:      dm(w+1) = my0;              {w[1] = w[0]}

       cntr = 3;                          {three input-off transients}
       do transients until ce;
              my1 = dm(w+3);              {get tap-3}
              dm(i5, m5) = my1;           {save in y and point to next y}

              mx0 = 0;
              dm(w) = mx0;                {put 0 in delay line}
                                          {update linear buffer}
              my0 = dm(w+2);              {w[2] = tap-2}
              dm(w+3) = my0;              {w[3] = w[2]}

              my0 = dm(w+1);              {w[1] = tap-1}
              dm(w+2) = my0;              {w[2] = w[1]}

              my0 = dm(w);                {w[0] = tap-0}
transients:   dm(w+1) = my0;              {w[1] = w[0]}

       idle;

.endmod;
