{delex2.dsp - delay example using circular buffer}
{Junior DSP Lab - Rutgers ECE Dept - S. J. Orfanidis - Jan 1996}

{Based on Example 4.2.1 of Introduction to Signal Processing}

.include <c:\adi_dsp\macros\dspmac.dsp>;         {DSP macros}

.module/ram/abs=0  delex1;

.var/dm      x[8];                    {input samples}
.var/dm      y[11];                   {output samples}
.var/dm/circ w[4];                    {circular delay-line buffer in DM}

.init  x: <xfir.hex>;
.init  w: 0x0000, 0x0000, 0x0000, 0x0000;

        jump start; nop; nop; nop;               {Interupt vector table}
        rti; nop; nop; nop;                      {No interrupts used}
        rti; nop; nop; nop;
        rti; nop; nop; nop;
        rti; nop; nop; nop;
        rti; nop; nop; nop;
        rti; nop; nop; nop;

start:  i2 = ^w;  L2 = %w;                {circular buffer}
        i3 = ^x;  m3 = 1;  L3 = 0;        {input samples}
        i5 = ^y;  m5 = 1;  L5 = 0;        {output samples}

       cntr = 8;
       do outputs until ce;               {process 8 input samples}
              m2 = 3; modify(i2, m2);     {point to tap-3}
              m2 = 0; my1 = dm(i2, m2);   {get tap-3}
              m2 =-3; modify(i2, m2);     {point back to tap-0}

              dm(i5, m5) = my1;           {write y}

              mx1 = dm(i3, m3);           {get input x}
              m2 = 0; dm(i2, m2) = mx1;   {put it into tap-0}

              m2 = -1;
outputs:      modify(i2, m2);             {backshift buffer pointer}

       cntr = 3;                          {3 input-off transients}
       do transients until ce;
              m2 = 3; modify(i2, m2);     {point to tap-3}
              m2 = 0; my1 = dm(i2, m2);   {get tap-3}
              m2 =-3; modify(i2, m2);     {point back to tap-0}

              dm(i5, m5) = my1;           {write y}

              mx1 = 0;                    {zero input x}
              m2 = 0; dm(i2, m2) = mx1;   {put it into tap-0}

              m2 = -1;
transients:   modify(i2, m2);             {backshift buffer pointer}

       idle;

.endmod;
