{dnsamp1.dsp - decimation/downsampling example}
{Junior DSP Lab - Rutgers ECE Dept - S. J. Orfanidis - Jan 1996}

.include <c:\adi_dsp\macros\dspmac.dsp>;         {DSP macros}

.module/ram/abs=0 decim1;

.const M = 3;                             {decimation ratio}
.const N = 8;                             {number of input samples}
.const A = 0x7fff;                        {sampling pulse amplitude, A=1}

.var/dm x[N];                             {input samples}
.var/dm y[N];                             {output samples}
.var/dm/circ s[M];                        {periodic pulse train}

i2 = ^x;  m2 = 1;  L2 = 0;                {input samples}
i3 = ^y;  m3 = 1;  L3 = 0;                {output samples}
i5 = ^s;  L5 = %s; m5 = 1;                {pulse train}

.init  x: <x.hex>;                        {read input samples from file}

        jump start; nop; nop; nop;        {Interupt vector table}
        rti; nop; nop; nop;               {No interrupts used}
        rti; nop; nop; nop;
        rti; nop; nop; nop;
        rti; nop; nop; nop;
        rti; nop; nop; nop;
        rti; nop; nop; nop;

start:

cntr=M;
do zero_s until ce;                       {initialize s to zero}
zero_s:   dm(i5, m5) = 0;

ax1 = A;                                  {set s[0] = A}
dm(s) = ax1;                              {s = [A,0,...,0] = A and M-1 zeros}

cntr=N;                                   {process N input samples}
do output until ce;
       mr1 = dm(i2, m2);                  {read input sample}

       ar = dm(i5, m5);                   {get sampling pulse}
       ar = pass ar;                      {forces updating of AZ flag}
       if ne jump output;                 {if AR != 0, write output}

       {else}  mr1 = 0;                   {if AR = 0, output is 0}

       output: dm(i3, m3) = mr1;          {write output sample}

idle;

.endmod;
