{firex1.dsp - FIR example using tapin, dot, cdelay}
{Junior DSP Lab - Rutgers ECE Dept - S. J. Orfanidis - Jan 1996}

{Based on Example 4.2.1 of Introduction to Signal Processing. The filter
 coefficients and are stored in the files h.dec/h.hex. The input and 
 output signals are in the files xfir.dec/xfir.hex, yfir.dec/yfir.hex.

     h = 0.25 =  1/4      x = 0.25 = 1/4      y = 0.0626 = 1/16
         0.50 =  2/4          0.25 = 1/4          0.1875 = 3/16
        -0.25 = -1/4          0.50 = 2/4          0.1875 = 3/16
         0.25 =  1/4          0.25 = 1/4          0.3125 = 5/16
                              0.50 = 2/4          0.1875 = 3/16
                              0.50 = 2/4          0.4375 = 7/16
                              0.25 = 1/4          0.2500 = 4/16
                              0.25 = 1/4          0.1875 = 3/16
                                                  0.1875 = 3/16
                                                  0.0000 = 0/16
                                                  0.0625 = 1/16

 (The h-coefficients and x have been scaled down to fit in 1.15 format,
 as compared to Example 4.2.1.)
}

.include <c:\adi_dsp\macros\dspmac.dsp>;         {DSP macros}

.module/ram/abs=0  firex1;

.const            L=8;                           {input signal length}
.const            M=3;                           {filter order}
.var/dm/ram       x[L];                          {input samples}
.var/dm/ram       y[L+M];                        {output samples}
.var/dm/ram/circ  w[M+1];                        {delay-line buffer in DM}
.var/pm/ram/circ  h[M+1];                        {filter taps in PM}

.init  x: <xfir.hex>;                            {read L input samples}
.init  h: <h.hex>;                               {read M+1 filter taps}

        jump start; nop; nop; nop;               {Interupt vector table}
        rti; nop; nop; nop;                      {No interrupts used}
        rti; nop; nop; nop;
        rti; nop; nop; nop;
        rti; nop; nop; nop;
        rti; nop; nop; nop;
        rti; nop; nop; nop;

start:  i2 = ^w;  m2 = 0;  L2 = %w;              {delay line buffer}
        i4 = ^h;  m4 = 0;  L4 = %h;              {filter taps buffer}
        i3 = ^x;  m3 = 1;  L3 = 0;               {input samples}
        i5 = ^y;  m5 = 1;  L5 = 0;               {output samples}

       zero(i2, m2, L2);                         {clear delay line}

       cntr = L;
       do outputs until ce;                      {process L input samples}
              ax0 = dm(i3, m3);                  {read x into AX0}
              tapin(i2, m2, ax0);                {put x in delay line}
              dot(M, i4, m4, i2, m2);            {compute output in MR1}
              cdelay(i2, m2);                    {update delay}
outputs:      dm(i5, m5) = mr1;                  {output y}

       cntr = M;                                 {M input-off transients}
       do transients until ce;
              ax0 = 0;                           {read x=0 into AX0}
              tapin(i2, m2, ax0);                {put it in delay line}
              dot(M, i4, m4, i2, m2);            {compute output in MR1}
              cdelay(i2, m2);                    {update delay}
transients:   dm(i5, m5) = mr1;                  {output y}

       idle;

.endmod;
