{quantex1.dsp - quantization example}
{Junior DSP Lab - Rutgers ECE Dept - S. J. Orfanidis - Jan 1996}

.include <c:\adi_dsp\macros\dspmac.dsp>;         {DSP macros}

.module/ram/abs=0 decim1;

.const B = 8;                      {quantization bits per sample}
.const L = 16 - B;                 {L least-significant bits thrown away}
.const N = 8;                      {number of input samples}

.var/dm x[N];                             {input samples}
.var/dm y[N];                             {output samples}

i2 = ^x;  m2 = 1;  L2 = 0;                {input samples}
i3 = ^y;  m3 = 1;  L3 = 0;                {output samples}

.init  x: <x.hex>;                        {read input samples from file}

        jump start; nop; nop; nop;        {Interupt vector table}
        rti; nop; nop; nop;               {No interrupts used}
        rti; nop; nop; nop;
        rti; nop; nop; nop;
        rti; nop; nop; nop;
        rti; nop; nop; nop;
        rti; nop; nop; nop;

start:

cntr=N;                                   {process N input samples}
do output until ce;
         mr1 = dm(i2, m2);                {read input sample}
         sr = ashift mr1 by -L (hi);      {shift it right by L bits}
         sr = ashift sr1 by  L (hi);      {shift it left by L bits}
output:  dm(i3, m3) = sr1;                {write output sample}

idle;

.endmod;
